/////////////////////////////////
/*       bc.name.js v1.02		*/
/*       by Benjamin Levy		*/
/*        23th July 2008		*/
/////////////////////////////////
/* Allows to automatically name a
   subpatcher/abstraction/bpatcher
   from inside and/or (re)name it
   with a message.				*/

// Global
autowatch=1;
inlets = 1;
outlets = 1;
setinletassist(0, "symbol / bang: set/reset the name");
setoutletassist(0, "symbol: name when set");

var Name;

// Args check
if(jsarguments.length>2)
	post("bc.name.js: too many arguments");

// Auto Naming from arg
if(jsarguments.length==2)
{
	Name=jsarguments[1];
	var AutoNaming=new Task(naming,this,Name);
	AutoNaming.schedule();
}

// Bang reapplies naming
function bang()
{
	if(Name)
		naming(Name);
	else
	{
		post();
		post("bc.name.js: no name");
	}
}

// Any symbol input renames
function anything()
{
	var Input = arrayfromargs(messagename,arguments)
	if(Input[1])
	{
		post();
		post("bc.name.js: too many symbols");
	}
	else
	{
		Name=messagename;
		naming(Name);
	}
}

// Common function to name
function naming(name)
{
	// name if any parent
	// ie if loaded as an abstraction,
	// a bpatcher or a subpatch
	if(this.patcher.box)
	{
		this.patcher.box.varname = name;
		outlet(0,name);
	}
}
